package lt05_pkg;

import java.awt.Color;
import java.awt.Component;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import lt05_pkg.PolkaDot;
import lt05_pkg.PolkaDotDataModel;

import javax.swing.JFrame;

/**
 * This class encapsulates a MouseListener that is installed upon a particular
 * JFrame. When a mouse clicked event is detected, this controller changes the
 * PolkaDotDataModel. For specific details, see
 * {@link #mouseClicked(MouseEvent)}
 * 
 * @author mb
 */
public class DotController_VersionForQuestion3 implements MouseListener,
		MouseMotionListener {

	private PolkaDotDataModel theModel;
	private JFrame theView;

	public DotController_VersionForQuestion3(JFrame view,
			PolkaDotDataModel model) {
		theModel = model;
		theView = view;

		/**
		 * The components of the view will generate events; these are produced
		 * when the user performs user actions. We want the controller to be
		 * aware of such events so that it can update the model accordingly.
		 * 
		 */
		theView.addMouseListener(this);
		theView.addMouseMotionListener(this);
	}

	/**
	 * This method causes the data model to be changed when a mouse click event
	 * is detected. What this method should do:
	 * 
	 * if the user clicks on a polka dot, then the polka dot should change its
	 * colour to another, randomly-selected colour. Hint: look at the services
	 * provided by the class {@link PolkaDot}
	 */
	@Override
	public void mouseClicked(MouseEvent e) {
		// the following statements are provided fyi
		// just because these statements are provided here does not mean that
		// you need to use them
		Component component = (Component) e.getSource();
		int width = component.getWidth();
		int height = component.getHeight();
	}

	@Override
	public void mousePressed(MouseEvent e) {
	}

	@Override
	public void mouseReleased(MouseEvent e) {
	}

	@Override
	public void mouseEntered(MouseEvent e) {
	}

	@Override
	public void mouseExited(MouseEvent e) {
	}

	@Override
	public void mouseDragged(MouseEvent e) {
	}

	@Override
	public void mouseMoved(MouseEvent e) {
	}

}
